#pragma once
#include <cstdint>
#include <ReMixer/Frequency.hpp>

namespace ReMixer {
    enum class SampleFormat {
        Unknown,
        Float16,
        Float32,
        Int16,
        Int32,
    };



    struct AudioFormat {
        uint32_t sample_rate;
        uint16_t channels;
        SampleFormat format;

        static AudioFormat StereoFloat(uint32_t rate) {
            return {rate, 2, SampleFormat::Float16};
        }

        static AudioFormat StereoFloat48kHz() {
            using namespace ReMixer::FrequencyLiterals;
            return StereoFloat(48_kHz);
        }
    };
}
