#pragma once
#include <cstdint>
#include <set>
#include <string>
#include <Event.h>
#include <ReMixer/AudioFormat.hpp>
#include <ReMixer/Sound.hpp>
#include <ReMixer/SoundHandle.hpp>
#include <ReMixer/IAudioDevice.hpp>

#include "Sound.hpp"

namespace ReMixer {


    /// TODO: Support JACK
    /// TOOD: Support ALSA
    /// TODO: Support PulseAudio
    /// TODO: Support WASAPI


    // TODO: Support Recording


    class Sound;
    class SoundHandle;

    class IAudioDevice;

    class Stream;
    class SoundSubsystem;
    class PulseAudioSubsystem;
    class PulseStream;


    void Init();
    void Cleanup();

#pragma region Simple API
    /// Simple high-level API for sound playback.
    /// @note Assumes you want the default device, and ideal parameters to properly play the sound.
    /// @return SoundHandle instance for managing the state of playback. (i.e. pause, seek, resume, playback speed, events.)
    SoundHandle* PlaySoundAsync(Sound& Sound);
    std::vector<IAudioDevice*> EnumerateDevices();
#pragma endregion

#pragma region Advanced API


#pragma endregion


}

