#pragma once
#include <ReMixer/Sound.hpp>

namespace ReMixer {
    class SoundHandle {
    public:
    protected:
        SoundHandle(const Sound& sound);


        void Pitch(float pitch);
        void Pan(float pan);
        void Volume(float volume);
        void SpatializationEnabled(bool enabled);
        //void SetPosition(const Vector3& position);
        //void SetDirection(const Vector3& direction);
        //void SetCone(const Cone& cone);
        //void SetVelocity(const Vector3& velocity);
        void DopplerFactor(float factor);
        void DirectionalAttenuationFactor(float factor);
        void RelativeToListener(bool relative);
        void MinDistance(float distance);
        void MaxDistance(float distance);
        void MinGain(float gain);
        void MaxGain(float gain);
        void Attenuation(float attenuation);

        float Pitch() const;
        float Pan() const;
        float Volume() const;
        bool SpatializationEnabled() const;
        //Vector3 Position() const;
        //Vector3 Direction() const;
        //Cone Cone() const;
        //Vector3 Velocity() const;
        float DopplerFactor() const;
        float DirectionalAttenuationFactor() const;
        bool RelativeToListener() const;
        float MinDistance() const;
        float MaxDistance() const;
        float MinGain() const;
        float MaxGain() const;
        float Attenuation() const;
    private:
    };


}
