#include <ReMixer/IStream.hpp>
#include <ReMixer/Sound.hpp>
#include <uuid/uuid.h>
#include <iostream>

void ReMixer::Stream::SetName(const std::string& name)
{
    this->name = name;
}

void ReMixer::Stream::SetSampleRate(uint sample_rate)
{
    this->sample_rate = sample_rate;
}

void ReMixer::Stream::SetChannelCount(uint channel_count)
{ this->channel_count = channel_count;}

void ReMixer::PulseStream::SetSampleRate(uint sampleRate)
{

    //pa_threaded_mainloop_lock(this->parent-)

    Stream::SetSampleRate(sampleRate);
    pa_operation* op;

    op = pa_stream_update_sample_rate(this->stream, sampleRate, OnStreamSuccess, this);

    pa_operation_unref(op);
}

void ReMixer::PulseStream::OnStreamStateChanged(pa_stream *s, void *userdata) {
    //std::cout << "stream state callback: ";

    auto *p = static_cast<pa_threaded_mainloop *>(userdata);

    auto state = pa_stream_get_state(s);
    switch(state) {
        case PA_STREAM_READY:
            std::cout << "Stream Ready" << std::endl;
            pa_threaded_mainloop_signal(p, 0);
            break;
        case PA_STREAM_FAILED:
            std::cout << "Stream Failed" << std::endl;
            pa_threaded_mainloop_signal(p, 0);
            break;
        case PA_STREAM_TERMINATED:
            std::cout << "Stream Terminated" << std::endl;
            pa_threaded_mainloop_signal(p, 0);
            break;
        case PA_STREAM_UNCONNECTED:
            std::cout << "Stream Unconnected" << std::endl;
            break;
        case PA_STREAM_CREATING:
            std::cout << "Stream Creating" << std::endl;
            break;
    }
}

void ReMixer::PulseStream::OnStreamRequest(pa_stream *s, size_t length, void *userdata) {
    //std::cout << "Received stream request callback: " << length << std::endl;

    auto *p = static_cast<pa_threaded_mainloop *>(userdata);

    pa_threaded_mainloop_signal(p, 0);
}

void ReMixer::PulseStream::OnLatencyUpdate(pa_stream *s, void *userdata) {
    //std::cout << "Received stream latency update callback" << std::endl;
    auto *p = static_cast<pa_threaded_mainloop *>(userdata);

    pa_threaded_mainloop_signal(p, 0);
}

void ReMixer::PulseStream::OnStreamSuccess(pa_stream *s, int success, void *userdata) {


}
